-module(server_genserver).
-export([main/0]).

% We have our server become a genserver (read genserver.erl to see the
% implementation)
start_server() ->
    genserver:start(server, undefined, fun server_fun/2).

% The server loop. Now no recursion, it looks like an ordinary function
server_fun(_State, {compute, Fun, Args}) ->
    Ans = apply(Fun, Args),
    timer:sleep(round(Ans) * 10),
    {reply, Ans, []}.


powers(Nums, Exp) ->
    Fun = fun(X, Y) -> round(math:pow(X, Y)) end,
    % We send messages using genserver:request. Note the 5000 as final
    % parameter, why do we do that? How can we fix the problem in other ways?
    Ans = [genserver:request(server, {compute, Fun, [Num, Exp]}, 5000) ||  Num <- Nums],
    io:fwrite("~p ^ ~p = ~p~n", [Nums, Exp, Ans]).


main() ->
    start_server(),

    powers([1,2,3,4], 3),
    powers([7,0,5,2], 3),
    powers([4,3,2,1], 3).
